# Requirements
coffee = require 'coffee-script'
util = require 'bal-util'
fs = require 'fs'
path = require 'path'

# Coffee4Clients
class Coffee4Clients
	options:
		server: null
		publicPath: null
		missingAction: false
		cache: false
	cache: {}
	
	# Setup our instance
	constructor: (options) ->
		# Prepare
		options or= {}
		for own key, value of options
			if options[key]?
				@options[key] = options[key]
		
		# Route
		@options.server.get /\.coffee$/, @process

	# Process a request
	process: (req,res) =>
		# Fetch
		@fetch req,res, (result) ->
			# Send
			res.writeHead 200, 'content-type': 'text/javascript'
			res.write result
			res.end()
	
	# Fetch a request's data
	fetch: (req,res,next) ->
		# Check cache
		if @options.cache and @cache[req.url]?
			return next @cache[req.url]
		
		# Fetch
		fileFullPath = @options.publicPath+req.url.replace(/\?.*$/,'')
		util.resolvePath fileFullPath, @options.publicPath, (err,fileFullPath,fileRelativePath) =>
			# Error
			if err
				if @options.missingAction
					return @options.missingAction req, res
				else
					throw err

			# Read
			fs.readFile fileFullPath, (err,data) =>
				# Error
				if err
					if @options.missingAction
						return @options.missingAction req, res
					else
						throw err

				# Render
				if path.extname(fileFullPath) is '.coffee' and /\?js$/i.test(req.url)
					result = coffee.compile(data.toString())
				else
					result = data.toString()
				
				# Cache
				if @options.cache
					@cache[req.url] = result

				# Next
				return next result

# Export
module.exports = {
	createInstance: (options) ->
		return new Coffee4Clients(options)
}