# -------------------------------------
# Header

# Requires
assert = require 'assert'
util = require 'bal-util'
request = require 'request'
express = require 'express'
coffee4clients = require __dirname+'/../lib/coffee4clients.coffee'

# Variables
cwd = process.cwd()
port = 5000
publicPath = __dirname+'/src'
requests =
	'a.coffee': 'alert "awesome"'
	'a.coffee?js': '(function() {\n  alert("awesome");\n}).call(this);\n'


# -------------------------------------
# Server

# Create Server
server = express.createServer()

# Configure
server.configure ->
	# Standard
	server.use express.errorHandler()
	server.use express.bodyParser()
	server.use express.methodOverride()

	# Routing
	server.use server.router
	server.use express.static publicPath
	coffee4clients.createInstance {
		server: server
		publicPath: publicPath
	}

# Listen
server.listen port


# -------------------------------------
# Tests

# Tests
tests =
	
	# Render
	'render': (beforeExit) ->
		# Prepare
		nTests = 2
		nTestsCompleted = 0
		checkRequest = (url,value) ->
			# Visit
			request.get {uri:'http://localhost:'+port+'/'+url}, (err,response,body) ->
				# no error
				assert.equal(err||false,false, 'render: no error')
				
				# equals
				assert.equal(body,value,'render: as expected')
				
				# completed
				++nTestsCompleted

				# done?
				if nTestsCompleted is nTests
					process.exit()

		# Requests
		for own url, value of requests
			checkRequest(url,value)
		
		# Async
		beforeExit ->
			assert.equal(nTests, nTestsCompleted, 'render: all tests ran')

# Export
module.exports = tests